Subject: Re: [PATCH v3] powerpc/ppc64: Use preempt_schedule_irq instead of preempt_schedule

From: Benjamin Herrenschmidt <[email-masked]>
Date: Sat, 07 Nov 2009 09:49:18 +1100

On Sat, 2009-11-07 at 01:38 +0300, Valentine wrote:
> Benjamin Herrenschmidt wrote:
> >> Yes, the MSR_EE is cleared before we jump to do_work. I'm OK with 
> >> clearing the hardirqenable flag. I just assumed that the hardirq flag 
> >> was supposed to reflect the MSR_EE state, so it looked a bit odd 
> >> clearing the MSR_EE at one place and then reflecting the change at another.
> > 
> > Yeah well, it is supposed to reflect EE in the "general case", it's just
> > that in the exception entry/exit, we take shortcuts when turning EE off
> > for short amount of times without reflecting it in the PACA. This is
> > why, in this case, since we are going back to C code, I want to have it
> > "fixed up" to reflect reality.
> > 
> 
> Ben, this one works fine. Are you going to pick it?

Already upstream:

Gitweb:
http://git.kernel.org/linus/4f917ba3d5ee9c98d60fa357e799942df8412de3
Commit:     4f917ba3d5ee9c98d60fa357e799942df8412de3
Parent:     01deab98e3ad8ff27243a8d5f8dd746c7110ae4f
Author:     Benjamin Herrenschmidt <[email-masked]>
AuthorDate: Mon Oct 26 19:41:17 2009 +0000
Committer:  Benjamin Herrenschmidt <[email-masked]>
CommitDate: Tue Oct 27 16:42:43 2009 +1100

    powerpc/ppc64: Use preempt_schedule_irq instead of preempt_schedule
    
    Based on an original patch by Valentine Barshak <[email-masked]>
    
    Use preempt_schedule_irq to prevent infinite irq-entry and
    eventual stack overflow problems with fast-paced IRQ sources.

    .../...

Now, it might be a good idea to do a -stable variant of it for 2.6.31
and back, but that will have to be a separate patch due to the new
Book3E churn in .32

Cheers,
Ben.